define([
   "dojo/_base/declare",
   "dojox/mvc/getStateful",
   "dojox/mvc/at",
   "aps/View",
   "aps/ResourceStore",
   "app/displayError",
   "aps/json!./newvps.json"
],
function (declare, getStateful, at, View, Store, displayError, newVPS) {
	var cNameNeeded = "no";

	return declare(View, {
		init: function() {
			this.vpsModel = getStateful({"data": newVPS});
			/* Define and return widgets */
			return ["aps/Panel", {
					id: this.genId("srvNew_page")
				},[
					["aps/FieldSet", {
							title: "General"
						}, [
							["aps/Output", {
								label: "Server Name",
								value: at(this.vpsModel.data, "name")
							}],
							["aps/Output", {
								label: "Description",
								value: at(this.vpsModel.data, "description")
							}],
							["aps/Output", {
							   id: this.genId("srvNew_domain"),
							   label: "Domain",
							   value: at(this.vpsModel.data, "domainName")
							}],
							["aps/Status", {
							   id: this.genId("srvNew_cName"),
							   label: "CNAME",
							   status: cNameNeeded,
							   useIcon: true,
							   statusInfo: {
							      "no": {
							         "label": "",
							         "type": "disabled",
							         "icon": "fa-minus"
							      },
							      "yes": {
							         "label": "",
							         "type": "success",
							         "icon": "fa-check"
							   }}
							}]
					]],
					["aps/FieldSet", {
							title: "Server Configuration"
						}, [
							["aps/Output", {
								label: "OS",
								value: at(this.vpsModel.data.platform.OS, "name")
							}],
							["aps/Output", {
								label: "CPU",
								value: at(this.vpsModel.data.hardware.CPU, "number")
							}],
							["aps/Output", {
								label: "Disk Space",
								value: at(this.vpsModel.data.hardware, "diskspace")
							}],
							["aps/Output", {
								label: "RAM",
								value: at(this.vpsModel.data.hardware, "memory")
							}]
					]]
				]
			];
		},
		onContext: function() {
			this.vpsModel.set("data",
				aps.context.wizardData["http://aps-standard.org/samples/dns1p#server-new-1"]
			);
			cNameNeeded = (this.vpsModel.data.get("cnameRecord")) ? "yes" : "no";
			this.byId("srvNew_cName").set("status", cNameNeeded);
			aps.apsc.hideLoading();
		},
		
		/* Define handlers for the navigation buttons */
		onNext: function() {
			aps.apsc.next();
		},
		
		onPrev: function() {
			aps.apsc.prev();
		}

   });
});
